;--------------------------------------------;
;   TENTO PROGRAM ZAZNAMENAVA VICE IR-KODU   ;
;         A SOUCASNE JE ROZPOZNAVA           ;
;  k monitorovani si spustte PC aplikaci,    ;
; ktera prijima data pomoci serioveho portu! ;
;--------------------------------------------;

	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	displej.inc
	#include	unibuff.inc
	#include	intervl2.inc
	#include	ir_rec2.inc
	#include	flash.inc
	#include	tab_util.inc
	#include	dskripty.inc
	#include	div16u.inc
	#include	vyber.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

MINPULZ	EQU	D'150'	; maximalni delka jednoznacne poruchy
ADIT_CH	EQU	D'100'

BLOK1	EQU	H'110'	; prvni kontinualni blok RAM
BLOK2	EQU	H'190'	; druhy kontinualni blok RAM
CK_ADR	EQU	D'2048'	; adresa prvniho zaznamu
BUFF_SIZE	EQU	D'64'	; velikost prijimaciho IR-bufferu

MINKOD	EQU	D'6'	; minimalni pripustna velikost kodu
MAXKOD	EQU	D'64'	; maximalni mozna velikost kodu
POCETKODU	EQU	D'10'	; pocet kodovych polozek v pameti

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

	CBLOCK	OFFRAM
	TML:1	; pro obsluhu displeje
	TMH:1
	DDATA:1

	BUFF_IN:1	; pro obsluhu bufferu
	BUFF_OUT:1
	BUFF_STAT:1
	BUFF_TEMP:1

	POZICE:1	; zaznam kodu do RAM
	KOD:2
	I1:2
	I2:2

	K_ADR:2	; promenna flash adresa

	AA:2	; pro skripty
	BB:2
	CC:2
	VD16U:1
	NUMFORM_:1

	KINDEX:1	; indexace zaznamu
	KINDEXY:POCETKODU
	ENDC

	CBLOCK	H'A0'	; usazeni bufferu do zbyle volne pameti
	BUFF_ADR:BUFF_SIZE
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	FSR_TEMP:1
	ENDC

;------------------------------------------------
; RESET / START	

	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	GOTO	START

;------------------------------------------------
; OBSLUHA PRERUSENI

	ORG	4
	MOVWF	W_TEMP		; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	MOVF	FSR,W
	MOVWF	FSR_TEMP
	banksel	0
	BTFSS	PIR1,TMR1IF	; pokud doslo k preteceni casovace
	GOTO	RB_INT
	MOVLW	D'0'	; ulozime do bufferu nulovou hodnotu (16 bitu)
	CALL	IN_BUFF
	MOVLW	D'0'
	CALL	IN_BUFF
	banksel	PIE1	; nasledne zakazeme dalsi preruseni od casovace
	BCF	PIE1,TMR1IE
	banksel	0
RB_INT	BTFSS	INTCON,RBIF	; testujeme preruseni od optoprijimace
	GOTO	INT_END
	MOVF	PORTB,F		; "refresujeme" porovnavaci registr
	BCF	INTCON,RBIF	; vynulujeme priznak
	BCF	T1CON,TMR1ON	; zastavime TMR1
	banksel	PIE1
	BSF	PIE1,TMR1IE	; povolime prerusemi od casovace
	banksel	PIR1
	BTFSS	PIR1,TMR1IF	; pokud TMR1 pretekl,...
	GOTO	VYSLI_H
	CLRF	TMR1H		; ..., potom jej vynulujeme
	CLRF	TMR1L
	BCF	PIR1,TMR1IF
VYSLI_H	MOVF	TMR1H,W		; vyssi byte TMR1 vlozime do bufferu
	CALL	IN_BUFF
	MOVF	TMR1H,F		; pokud je vyssi byte nulovy,...
	BTFSS	STATUS,Z
	GOTO	SKOK
	MOVF	TMR1L,W		; ...potom testujeme zda je nulova
	BTFSC	STATUS,Z
	GOTO	SKOK
	SUBLW	MINPULZ		; pokud neni nulova,...
	BTFSS	STATUS,C		; ...testujeme, zda neni prilis mala
	GOTO	SKOK
	CLRF	TMR1L		; pokud je nenulova, ale mala,...
	BSF	PIR1,TMR1IF	; ...potom predstirame chybu v budoucim mereni
SKOK	MOVF	TMR1L,W		; zde vkladame nizsi byte TMR1 do bufferu
	CALL	IN_BUFF
	CLRF	TMR1H		; nulujeme TMR1
	CLRF	TMR1L
	BSF	T1CON,TMR1ON	; TMR1 je spusten

INT_END	MOVF	FSR_TEMP,W	; obnova registru ze zalohy
	MOVWF	FSR
	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE

;-------------------------------------
; INICIALIZACE
	
START	
	banksel	TRISB
	BCF	TRISB,4	; musi byt nastaveno jako vystup
	BCF	TRISB,5
	BCF	TRISB,6
	BSF	TRISB,7	; sem je pripojen optoprijimac
	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'64'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 19200 baudu
	MOVWF	SPBRG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA a PORTE jako "logicky"
	MOVWF	ADCON1
	banksel	0
	
	; inicializace bufferu
	BUFFINI 	BUFF_IN, BUFF_OUT,BUFF_STAT

	banksel	T1CON	; nastaveni TMR1 (predelicka 1:4);
	MOVLW	B'00101101'
	MOVWF	T1CON

	; inicializace displeje
	CALL	INITDISP
	; napis: "vygenerujte novy IR-kod"
	MOVLW	D'0'
	CALL	SKRIPT

	BSF	INTCON,RBIE	; povoleno preruseni od optoprijimace
	BSF	INTCON,PEIE	; povoleno preruseni od nektere periferie (v tomto pripade TMR1)
	BSF	INTCON,GIE	; aktivace systemu preruseni

;-----------------------------------------------------------
; HLAVNI PROGRAM

	CLRF	POZICE	; ukazatel do zaznamu je nastaven na prvni polozku
LOOP	MOVF	BUFF_STAT,F
	BTFSC	STATUS,Z	; pokud je v bufferu hodnota,... 
	GOTO	LOOP
	CALL	OUT_BUFF	; ...ulozime ji do promenne KOD
	MOVWF	KOD+1
	CALL	OUT_BUFF
	MOVWF	KOD
	KRATIT_14	KOD	; !!!zkraceni KODu na 14 bitu!!!
	CALL	IR_REC	; volame zaznamenavaci podprogram
	BTFSS	STATUS,C	; je zaznam hotov?
	GOTO	LOOP	; - pokud ne, opakujeme cyklus
	
	; uzivatel vybere index zaznamu
	VYBER_	CK_ADR, K_ADR, BUFF_SIZE, KINDEX, POCETKODU, SKRIPT, D'1', DDELAY
	; novy zaznam se ulozi bo zvolene oblasti (viz. index)
	SAVE_REC_	KOD, POZICE, BLOK1, BLOK2, K_ADR

	MOVLW	D'2'	; napis: "otestujte prijem"
	CALL	SKRIPT

	INDEXNUL_	KINDEX, POCETKODU, KINDEXY ; vynulovani vsech indexu (tedy pro vsechny zaznamy)
LOOP2	MOVF	BUFF_STAT,F
	BTFSC	STATUS,Z	; pokud je v bufferu hodnota...
	GOTO	LOOP2
	CALL	OUT_BUFF	; precteme ji...
	MOVWF	KOD+1
	CALL	OUT_BUFF
	MOVWF	KOD
	KRATIT_14	KOD	; !!!zkraceni KODu na 14 bitu!!!
	INTERVAL_	KOD, I1, I2, ADIT_CH	; spocteme tolerancni interval
LOOP1_
	PRVNI_K	CK_ADR, K_ADR, KINDEX, KINDEXY	; nastaveni na prvni zaznam
LOOP2_	CALL	FLRD_REC	; precteme aktualni hodnotu ze zaznamu
	MOVF	KOD,F	; testujeme zda je hodnota nulova
	BTFSS	STATUS,Z
	GOTO	POROVNEJ
	MOVF	KOD+1,F
	BTFSC	STATUS,Z
	GOTO	POZNAL	; - pokud je nulova, znamena to, ze jsme na konci zaznamu a doslo k celkove shode
POROVNEJ			; - v opacnem pripade porovnavame...
	UVNITR_	KOD, I1, I2
	BTFSS	STATUS,C	; lezi KOD v intervalu?
	CLRF	INDF	; - pokud ne, resetujeme ukazatel do zaznamu
	DALSI_K	CK_ADR, K_ADR, BUFF_SIZE, KINDEX, POCETKODU, KINDEXY ; prejdeme na dalsi zaznam
	BTFSC	STATUS,Z	; pokud byl predchozi zaznam posledni...
	GOTO	LOOP2	; ...potom musime prijmout z bufferu dalsi hodnotu
	GOTO	LOOP2_	; ...v opacnem pripade musime porovnat hodnotu z dalsiho zaznamu

POZNAL	MOVLW	D'133'	; kod byl rozpoznan...
	BTFSS	PIR1,TXIF	; na port vysleme cislo indexu, jehoz zaznam byl rozpoznan
	GOTO	$ - 1
	MOVWF	TXREG
	MOVLW	D'0'
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KINDEX,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	CLRF	INDF	; nulujeme aktualni ukazatel do zaznamu
	MOVLW	D'3'	; vypiseme cislo indexu na displej
	CALL	SKRIPT
	DALSI_K	CK_ADR, K_ADR, BUFF_SIZE, KINDEX, POCETKODU, KINDEXY	; prejdeme na dalsi zaznam
	BTFSC	STATUS,Z	; pokud byl predchozi zaznam posledni...
	GOTO	LOOP2	; ...potom musime prijmout z bufferu dalsi hodnotu
	GOTO	LOOP2_	; ...v opacnem pripade musime porovnat hodnotu z dalsiho zaznamu

	; ukladani do bufferu
IN_BUFF	INBUFF_	BUFF_ADR, BUFF_SIZE, BUFF_IN, BUFF_OUT, BUFF_STAT, BUFF_TEMP, 0
	RETURN
	
	; cteni z bufferu
OUT_BUFF	OUTBUFF_	BUFF_ADR, BUFF_SIZE, BUFF_IN, BUFF_OUT, BUFF_STAT, BUFF_TEMP, 1
	RETURN
	
	; zaznamenavani kodu do staticke pameti
IR_REC	IR_REC_	KOD, POZICE, BLOK1, BLOK2, MINKOD, MAXKOD
	RETURN

	; cteni kodu z flash pameti
FLRD_REC	FLRD_REC_	KOD, INDF, K_ADR
	RETURN

	; deleni
DIV16U	DIV16U_M	AA,BB,CC,VD16U 

	; interpret zobrazovacich skriptu
SKRIPT	SKRIPT_	TABULKY, PUTZNAK, DPRIKAZ, NUMFORM_, DIV16U, AA, BB, CC
	RETURN

	; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS


; ukazatele na zobrazovaci skripty
TABULKY	DATA	NAPIS1
	DATA	NAPIS2
	DATA	NAPIS3
	DATA	NAPIS4
; zobrazovaci skripty
NAPIS1	POS_D	D'0'
	DE	"vygenerujte novy"
	POS_D	D'64'
	DE	"!!  IR - kod  !!"
	EOFS
NAPIS2	POS_D	D'0'
	DE	" kam to ulozit? "
	POS_D	D'64'
	DE	" do zaznamu:"
	PRINTV	KINDEX,B'00111',0,0,0,1
	DBLOK	' ',D'3'
	EOFS
NAPIS3	DRESET
	DE	"otestujte prijem"
	EOFS
NAPIS4	POS_D	D'64'
	PRINTV	KINDEX,B'00111',0,0,0,1
	DBLOK	' ',D'3'
	EOFS

; uzivatelskou FLASH pamet zaplnime jednickami (vymazani minulych zaznamu)
	ORG	CK_ADR
	FILL	H'3FFF', D'65' * D'10'

	END
