;--------------------------------------------;
; TENTO PROGRAM PRIJIMA DATA Z PC-KLAVESNICE ;
;   spustte si PC aplikaci, ktera prijima    ;
; data pomoci serioveho portu: KEY_VIEW.EXE  ;
;--------------------------------------------;

	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"

#DEFINE	CLOCK	PORTB,0	; hodiny z klavesnice
#DEFINE	KEYDATA	PORTB,6	; data z klavesnice

	CBLOCK	OFFRAM
	KEYCOUNT:1	; pro praci s klavesnici
	KEYKOD:2
	ENDC

	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI

	banksel	TRISB	; vstup z klavesnice
	BSF	TRISB,0
	BSF	TRISB,6
	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'10'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 115200 baudu
	MOVWF	SPBRG
	banksel	0

LOOP	CALL	PRIJMOUT
	MOVLW	D'133'	; ...potom posleme na TX-port hodnotu 133
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KEYKOD+1,W	; ...potom pecteme z bufferu a posleme na port dva byty
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KEYKOD,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	GOTO	LOOP	; navrat k testovani bufferu

;----------------------------------
; prijimani kodu z klavesnice

PRIJMOUT	MOVLW	D'11'	; 11 bitu
	MOVWF	KEYCOUNT
KEYLOOP	BTFSC	CLOCK
	GOTO	$ - 1	; cekame na spadovou hranu hodin
	BCF	KEYKOD+1,3 ; (prednastaveni bitu vystupu)
	BTFSS	CLOCK	
	GOTO	$ - 1	; cekame na nabeznou hranu hodin
	BTFSC	KEYDATA
	BSF	KEYKOD+1,3	; definujeme bit vystupu
	RRF	KEYKOD+1,F	; bitove posunujeme vystupni slovo
	RRF	KEYKOD,F
	DECFSZ	KEYCOUNT,F	; konec cyklu
	GOTO	KEYLOOP
	MOVF	KEYKOD+1,W
	ANDLW	B'00000111'	; orezavaci maska
	MOVWF	KEYKOD+1
	RETURN

	END
